{
"resultCode": "A001215",
"resultMessage": "[A001215] /auth/authorization, The client (ID = 26837717140341) is locked."
}
{
"resultCode": "A001311",
"resultMessage": "[A001311] /auth/authorization, Too many requests, retry after 1 seconds. (Entity: 23769878923/87122303)"
}
{
"resultCode": "A001101",
"resultMessage": "[A001101] /auth/authorization, Authlete Server error."
}
Token Endpoint
Process Token Request
This API parses request parameters of an authorization request and returns necessary data for the authorization server implementation to process the authorization request further.
POST
/
api
/
{serviceId}
/
auth
/
token
Typescript (SDK)
import { Authlete } from "@authlete/typescript-sdk";const authlete = new Authlete({ serviceId: "<id>", bearer: process.env["AUTHLETE_BEARER"] ?? "",});async function run() { const result = await authlete.token.process({ tokenRequest: { parameters: "grant_type=authorization_code&code=Xv_su944auuBgc5mfUnxXayiiQU9Z4-T_Yae_UfExmo&redirect_uri=https%3A%2F%2Fmy-client.example.com%2Fcb1&code_verifier=dBjftJeZ4CVP-mB92K27uhbUJU1p1r_wW1gFWFOEjXk", clientId: "26478243745571", clientSecret: "gXz97ISgLs4HuXwOZWch8GEmgL4YMvUJwu3er_kDVVGcA0UOhA9avLPbEmoeZdagi9yC_-tEiT2BdRyH9dbrQQ", }, }); console.log(result);}run();
require 'authlete_ruby_sdk'
Models = ::Authlete::Models
s = ::Authlete::Client.new(
service_id: '<id>',
bearer: '<YOUR_BEARER_TOKEN_HERE>'
)
res = s.tokens.process_request(token_request: Models::Components::TokenRequest.new(
parameters: 'grant_type=authorization_code&code=Xv_su944auuBgc5mfUnxXayiiQU9Z4-T_Yae_UfExmo&redirect_uri=https%3A%2F%2Fmy-client.example.com%2Fcb1&code_verifier=dBjftJeZ4CVP-mB92K27uhbUJU1p1r_wW1gFWFOEjXk',
client_id: '26478243745571',
client_secret: 'gXz97ISgLs4HuXwOZWch8GEmgL4YMvUJwu3er_kDVVGcA0UOhA9avLPbEmoeZdagi9yC_-tEiT2BdRyH9dbrQQ'
))
unless res.token_response.nil?
# handle response
end
{
"resultCode": "A001215",
"resultMessage": "[A001215] /auth/authorization, The client (ID = 26837717140341) is locked."
}
{
"resultCode": "A001311",
"resultMessage": "[A001311] /auth/authorization, Too many requests, retry after 1 seconds. (Entity: 23769878923/87122303)"
}
{
"resultCode": "A001101",
"resultMessage": "[A001101] /auth/authorization, Authlete Server error."
}
Full description
This API is supposed to be called from with the implementation of the token endpoint of the service. The endpoint implementation must extract the request parameters from the token request from the client application and pass them as the value of parameters request parameter to Authlete’s /auth/token API. The value of parameters is the entire entity body (which is formatted in application/x-www-form-urlencoded) of the token request. In addition, if the token endpoint of the authorization server implementation supports basic authentication as a means of client authentication, the client credentials must be extracted from Authorization header and they must be passed as clientId request parameter and clientSecret request parameter to Authlete’s /auth/token API. The following code snippet is an example in JAX-RS showing how to extract request parameters from the token request and client credentials from Authorization header.
@POST@Consumes(MediaType.APPLICATION_FORM_URLENCODED)public Response post(@HeaderParam(HttpHeaders.AUTHORIZATION) String auth,String parameters){// Convert the value of Authorization header (credentials of// the client application), if any, into BasicCredentials.BasicCredentials credentials = BasicCredentials.parse(auth);// The credentials of the client application extracted from// 'Authorization' header. These may be null.String clientId = credentials == null ? null: credentials.getUserId();String clientSecret = credentials == null ? null: credentials.getPassword();// Process the given parameters.return process(parameters, clientId, clientSecret);}
Note: The jwtAtClaims request parameter is effective only when this API directly issues an access token, i.e., in the client_credentials grant flow (and the Native SSO branch of Token Exchange). For other grant flows, additional JWT claims must be set via the corresponding API instead: /auth/authorization/issue (authorization_code), /auth/backchannel/authentication/complete (CIBA), or /auth/device/complete (device_code). jwtAtClaims is silently ignored when sent with other grants.The response from /auth/token API has some parameters. Among them, it is action parameter that the service implementation should check first because it denotes the next action that the authorization server implementation should take. According to the value of action, the authorization server implementation must take the steps described below.
When the value of action is INTERNAL_SERVER_ERROR, it means that the request from the authorization server implementation was wrong or that an error occurred in Authlete. In either case, from the viewpoint of the client application, it is an error on the server side. Therefore, the service implementation should generate a response to the client application with HTTP status of “500 Internal Server Error”. Authlete recommends application/json as the content type although OAuth 2.0 specification does not mention the format of the error response when the redirect URI is not usable. The value of responseContent is a JSON string which describes the error, so it can be used as the entity body of the response.The following illustrates the response which the service implementation should generate and return to the client application.
HTTP/1.1 500 Internal Server ErrorContent-Type: application/jsonCache-Control: no-storePragma: no-cache{responseContent}
The endpoint implementation may return another different response to the client application since “500 Internal Server Error” is not required by OAuth 2.0.
When the value of action is INVALID_CLIENT, it means that authentication of the client failed. In this case, the HTTP status of the response to the client application is either “400 Bad Request” or “401 Unauthorized”. This requirement comes from RFC 6749, 5.2. Error Response. The description about invalid_client shown below is an excerpt from RFC 6749.Client authentication failed (e.g., unknown client, no client authentication included, or unsupported authentication method). The authorization server MAY return an HTTP 401 (Unauthorized) status code to indicate which HTTP authentication schemes are supported. If the client attempted to authenticate via the Authorization request header field, the authorization server MUST respond with an HTTP 401 (Unauthorized) status code and include the WWW-Authenticate response header field matching the authentication scheme used by the client.In either case, the value of responseContent is a JSON string which can be used as the entity body of the response to the client application.The following illustrate responses which the service implementation must generate and return to the client application.
HTTP/1.1 400 Bad RequestContent-Type: application/jsonCache-Control: no-storePragma: no-cache{responseContent}
When the value of action is BAD_REQUEST, it means that the request from the client application is invalid. A response with HTTP status of “400 Bad Request” must be returned to the client application and the content type must be application/json. The value of responseContent is a JSON string which describes the error, so it can be used as the entity body of the response.The following illustrates the response which the service implementation should generate and return to the client application.
HTTP/1.1 400 Bad RequestContent-Type: application/jsonCache-Control: no-storePragma: no-cache{responseContent}
When the value of "action" is "PASSWORD", it means that the request from the client application is valid and grant_type is "password". That is, the flow is “Resource Owner Password Credentials”. In this case, {@link #getUsername()} returns the value of "username" request parameter and {@link #getPassword()} returns the value of {@code “password”} request parameter which were contained in the token request from the client application. The service implementation must validate the credentials of the resource owner (= end-user) and take either of the actions below according to the validation result.
When the credentials are valid, call Authlete’s /auth/token/issue} API to generate an access token for the client application. The API requires "ticket" request parameter and "subject" request parameter. Use the value returned from {@link #getTicket()} method as the value for "ticket" parameter.
The response from /auth/token/issue API ({@link TokenIssueResponse}) contains data (an access token and others) which should be returned to the client application. Use the data to generate a response to the client application.
When the credentials are invalid, call Authlete’s {@code /auth/token/fail} API with reason={@link TokenFailRequest.Reason#INVALID_RESOURCE_OWNER_CREDENTIALS INVALID_RESOURCE_OWNER_CREDENTIALS} to generate an error response for the client application. The API requires "ticket" request parameter. Use the value returned from {@link #getTicket()} method as the value for "ticket" parameter.
The response from /auth/token/fail API ({@link TokenFailResponse}) contains error information which should be returned to the client application. Use it to generate a response to the client application.
When the value of action is OK, it means that the request from the client application is valid and an access token, and optionally an ID token, is ready to be issued. The HTTP status of the response returned to the client application must be “200 OK” and the content type must be application/json. The value of responseContent is a JSON string which contains an access token (and optionally an ID token), so it can be used as the entity body of the response.The following illustrates the response which the service implementation must generate and return to the client application.
When the value of "action" is "TOKEN_EXCHANGE", it means that the request from the client application is a valid token exchange request (cf. RFC 8693 OAuth 2.0 Token Exchange) and that the request has already passed the following validation steps.
Confirm that the value of the requested_token_type request parameter is one of the registered token type identifiers if the request parameter is given and its value is not empty.
Confirm that the subject_token request parameter is given and its value is not empty.
Confirm that the subject_token_type request parameter is given and its value is one of the registered token type identifiers.
Confirm that the actor_token_type request parameter is given and its value is one of the registered token type identifiers if the actor_token request parameter is given and its value is not empty.
Confirm that the actor_token_type request parameter is not given or its value is empty when the actor_token request parameter is not given or its value is empty. Furthermore, Authlete performs additional validation on the tokens specified by the subject_token request parameter and the actor_token request parameter according to their respective token types as shown below.
Check if the JWT is encrypted and if it is encrypted, then (a) reject the token exchange request when the {@link Service#isTokenExchangeEncryptedJwtRejected() tokenExchangeEncryptedJwtRejected} flag of the service is true or (b) skip remaining validation steps when the flag is false. Note that Authlete does not verify an encrypted JWT because there is no standard way to obtain the key to decrypt the JWT with. This means that you must verify an encrypted JWT by yourself when one is used as an input token with the token type { @code “urn:ietf:params:oauth:token-type:jwt” }.
Confirm that the current time has not reached the time indicated by the exp claim if the JWT contains the claim.
Confirm that the current time is equal to or after the time indicated by the iat claim if the JWT contains the claim. 5.Confirm that the current time is equal to or after the time indicated by the nbf claim if the JWT contains the claim.
Check if the JWT is signed and if it is not signed, then (a) reject the token exchange request when the {@link Service#isTokenExchangeUnsignedJwtRejected() tokenExchangeUnsignedJwtRejected} flag of the service is true or (b) finish validation on the input token. Note that Authlete does not verify the signature of the JWT because there is no standard way to obtain the key to verify the signature of a JWT with. This means that you must verify the signature by yourself when a signed JWT is used as an input token with the token type "urn:ietf:params:oauth:token-type:jwt". *Token Type: urn:ietf:params:oauth:token-type:access_token*
Confirm that the token is an access token that has been issued by the Authlete server of your service. This implies that access tokens issued by other systems cannot be used as a subject token or an actor token with the token type urn:ietf:params:oauth:token-type:access_token.
Confirm that the access token has not expired.
Confirm that the access token belongs to the service. *Token Type: urn:ietf:params:oauth:token-type:refresh_token*
Confirm that the token is a refresh token that has been issued by the Authlete server of your service. This implies that refresh tokens issued by other systems cannot be used as a subject token or an actor token with the token type urn:ietf:params:oauth:token-type:refresh_token.
Confirm that the refresh token has not expired.
Confirm that the refresh token belongs to the service. *Token Type: urn:ietf:params:oauth:token-type:id_token*
Confirm that the format conforms to the JWT specification (RFC 7519).
Check if the ID Token is encrypted and if it is encrypted, then (a) reject the token exchange request when the {@link Service#isTokenExchangeEncryptedJwtRejected() tokenExchangeEncryptedJwtRejected} flag of the service is true or (b) skip remaining validation steps when the flag is false. Note that Authlete does not verify an encrypted ID Token because there is no standard way to obtain the key to decrypt the ID Token with in the context of token exchange where the client ID for the encrypted ID Token cannot be determined. This means that you must verify an encrypted ID Token by yourself when one is used as an input token with the token type "urn:ietf:params:oauth:token-type:id_token".
Confirm that the ID Token contains the exp claim and the current time has not reached the time indicated by the claim.
Confirm that the ID Token contains the iat claim and the current time is equal to or after the time indicated by the claim.
Confirm that the current time is equal to or after the time indicated by the nbf claim if the ID Token contains the claim.
Confirm that the ID Token contains the iss claim and the value is a valid URI. In addition, confirm that the URI has the https scheme, no query component and no fragment component.
Confirm that the ID Token contains the aud claim and its value is a JSON string or an array of JSON strings.
Confirm that the value of the nonce claim is a JSON string if the ID Token contains the claim.
Check if the ID Token is signed and if it is not signed, then (a) reject the token exchange request when the {@link Service#isTokenExchangeUnsignedJwtRejected() tokenExchangeUnsignedJwtRejected} flag of the service is true or (b) finish validation on the input token.
Confirm that the signature algorithm is asymmetric. This implies that ID Tokens whose signature algorithm is symmetric (HS256, HS384 or HS512) cannot be used as a subject token or an actor token with the token type urn:ietf:params:oauth:token-type:id_token.
Verify the signature of the ID Token. Signature verification is performed even in the case where the issuer of the ID Token is not your service. But in that case, the issuer must support the discovery endpoint defined in OpenID Connect Discovery 1.0. Otherwise, signature verification fails. *Token Type: urn:ietf:params:oauth:token-type:saml1* (Authlete does not perform any validation for this token type.) *Token Type: urn:ietf:params:oauth:token-type:saml2* (Authlete does not perform any validation for this token type.) The specification of Token Exchange (RFC 8693) is very flexible. In other words, the specification has abandoned the task of determining details. Therefore, for secure token exchange, you have to complement the specification with your own rules. For that purpose, Authlete provides some configuration options as listed below. Authorization server implementers may utilize them and/or implement their own rules. In the case of {@link Action#TOKEN_EXCHANGE TOKEN_EXCHANGE}, the {@link #getResponseContent()} method returns null. You have to construct the token response by yourself. For example, you may generate an access token by calling Authlete’s /api/auth/token/create API and construct a token response like below.
Confirm that the assertion request parameter is given and its value is not empty.
Confirm that the format of the assertion conforms to the JWT specification (RFC 7519).
Check if the JWT is encrypted and if it is encrypted, then (a) reject the token request when the {@link Service#isJwtGrantEncryptedJwtRejected() jwtGrantEncryptedJwtRejected} flag of the service is true or (b) skip remaining validation steps when the flag is false. Note that Authlete does not verify an encrypted JWT because there is no standard way to obtain the key to decrypt the JWT with. This means that you must verify an encrypted JWT by yourself.
Confirm that the JWT contains the iss claim and its value is a JSON string.
Confirm that the JWT contains the sub claim and its value is a JSON string.
Confirm that the JWT contains the aud claim and its value is either a JSON string or an array of JSON strings.
Confirm that the issuer identifier of the service (cf. {@link Service#getIssuer()}) or the URL of the token endpoint (cf. {@link Service#getTokenEndpoint()}) is listed as audience in the aud claim.
Confirm that the JWT contains the exp claim and the current time has not reached the time indicated by the claim.
Confirm that the current time is equal to or after the time indicated by by the iat claim if the JWT contains the claim.
Confirm that the current time is equal to or after the time indicated by by the nbf claim if the JWT contains the claim.
Check if the JWT is signed and if it is not signed, then (a) reject the token request when the {@link Service#isJwtGrantUnsignedJwtRejected() jwtGrantUnsignedJwtRejected} flag of the service is true or (b) finish validation on the JWT. Note that Authlete does not verify the signature of the JWT because there is no standard way to obtain the key to verify the signature of a JWT with. This means that you must verify the signature by yourself. Authlete provides some configuration options for the grant type as listed below. Authorization server implementers may utilize them and/or implement their own rules.
Finally, note again that Authlete does not verify the signature of the JWT specified by the assertion request parameter. You must verify the signature by yourself.
Authenticate every request with a Service Access Token or Organization Token. Set the token value in the Authorization: Bearer <token> header.
Service Access Token: Scoped to a single service. Use when automating service-level configuration or runtime flows.
Organization Token: Scoped to the organization; inherits permissions across services. Use for org-wide automation or when managing multiple services programmatically.
Both token types are issued by the Authlete console or provisioning APIs.
OAuth 2.0 token request parameters which are the request parameters that the OAuth 2.0 token endpoint of the authorization server implementation received from the client application.
The value of parameters is the entire entity body (which is formatted in application/x-www-form-urlencoded) of the request from the client application.
The client ID extracted from Authorization header of the token request from the client application.
If the token endpoint of the authorization server implementation supports basic authentication as a means of client authentication, and the request from the client application contained its client ID in Authorization header, the value should be extracted and set to this parameter.
The client secret extracted from Authorization header of the token request from the client application.
If the token endpoint of the authorization server implementation supports basic authentication as a means of client authentication, and the request from the client application contained its client secret in Authorization header, the value should be extracted and set to this parameter.
Additional claims that are added to the payload part of the JWT access token.
Effective only in the client_credentials grant flow (and the Native SSO branch of Token Exchange). For other grant flows, set additional JWT claims via the corresponding API: /auth/authorization/issue (authorization_code), /auth/backchannel/authentication/complete (CIBA), /auth/device/complete (device_code). The parameter is silently ignored when sent with other grants.
The duration (in seconds) of the access token that may be issued as a result of the Authlete API call.
When this request parameter holds a positive integer, it is used as the duration of the access token in. In other cases, this request parameter is ignored.
The duration (in seconds) of the refresh token that may be issued as a result of the Authlete API call.
When this request parameter holds a positive integer, it is used as the duration of the refresh token in. In other cases, this request parameter is ignored.
The flag indicating whether to require the DPoP proof JWT to include the nonce claim. Even if the service's dpopNonceRequired property is false, calling the /auth/token API with this dpopNonceRequired parameter true will force the Authlete API to check whether the DPoP proof JWT includes the expected nonce value.
The content that the authorization server implementation is to return to the client application. Its format varies depending on the value of action parameter.
The value of username request parameter in the token request. The client application must specify username when it uses Resource Owner Password Grant. In other words, when the value of grant_type request parameter is password, username request parameter must come along.
This parameter has a value only if the value of grant_type request parameter is password and the token request is valid.
The value of password request parameter in the token request. The client application must specify password when it uses Resource Owner Password Grant. In other words, when the value of grant_type request parameter is password, password request parameter must come along.
This parameter has a value only if the value of grant_type request parameter is password and the token request is valid.
The newly issued ID token. Note that an ID token is issued from a token endpoint only when the response_type request parameter of the authorization request to an authorization endpoint has contained code and the scope request parameter has contained openid.
The client ID alias when the token request was made. If the client did not have an alias, this parameter is null. Also, if the token request was invalid and it failed to identify a client, this parameter is null.
The flag which indicates whether the client ID alias was used when the token request was made. true if the client ID alias was used when the token request was made.
The subject (= resource owner's ID) of the access token. Even if an access token has been issued by the call of /api/auth/token API, this parameter is null if the flow of the token request was Client Credentials Flow (grant_type=client_credentials) because it means the access token is not associated with any specific end-user.
The newly issued access token in JWT format. If the authorization server is configured to issue JWT-based access tokens (= if the service's accessTokenSignAlg value is a non-null value), a JWT-based access token is issued along with the original random-string one.
The authorization details. This represents the value of the authorization_details request parameter in the preceding device authorization request which is defined in "OAuth 2.0 Rich Authorization Requests".
If the response from the /auth/token API contains the deviceSecret parameter, its value should be used as the value of this deviceSecret request parameter to the /nativesso API. The authorization server may choose to issue a new device secret; in that case, it is free to generate a new device secret and specify the new value.
The authorization server should compute the hash value of the device secret based on its own logic and specify the computed hash as the value of this deviceSecretHash request parameter to the /nativesso API.
Flag indicating whether a metadata document was used to resolve client metadata for this request.
When true, the client metadata was retrieved via the CIMD mechanism rather than from the Authlete database.
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Authlete Documentation","colors":{"primary":"#0057B7","light":"#4D8FEA","dark":"#0057B7"},"logo":{"light":"https://mintcdn.com/authlete/EJDZNZMvOu_9CJHJ/authlete-blue-horizontal-logo.svg?fit=max\u0026auto=format\u0026n=EJDZNZMvOu_9CJHJ\u0026q=85\u0026s=ed123a3de8b7791dffde03e7705c7460","dark":"https://mintcdn.com/authlete/EJDZNZMvOu_9CJHJ/authlete-blue-horizontal-logo.svg?fit=max\u0026auto=format\u0026n=EJDZNZMvOu_9CJHJ\u0026q=85\u0026s=ed123a3de8b7791dffde03e7705c7460"},"favicon":{"light":"https://mintcdn.com/authlete/gV1fxQkuH3uz_H3j/images/favicon-32x32.png?fit=max\u0026auto=format\u0026n=gV1fxQkuH3uz_H3j\u0026q=85\u0026s=9838a40b23e11ab35d7737e4c94a2d9a","dark":"https://mintcdn.com/authlete/gV1fxQkuH3uz_H3j/images/favicon-32x32.png?fit=max\u0026auto=format\u0026n=gV1fxQkuH3uz_H3j\u0026q=85\u0026s=9838a40b23e11ab35d7737e4c94a2d9a"},"api":{"openapi":"https://spec.speakeasy.com/authlete/sdk-workspace/authlete-api-explorer-with-code-samples","playground":{"display":"interactive","proxy":true},"examples":{"languages":["typescript","ruby","go","shell"],"autogenerate":true},"mdx":{"auth":{"method":"bearer"},"server":"https://us.authlete.com"}},"navbar":{"primary":{"type":"button","label":"Get Started","href":"https://console.authlete.com/"}},"footer":{"socials":{"x":"https://x.com/authlete","github":"https://github.com/authlete","linkedin":"https://linkedin.com/company/authlete"}},"contextual":{"options":["copy","view","chatgpt","claude","mcp","cursor"],"display":"header"},"thumbnails":{"fonts":{"family":"Noto Sans JP"}},"markdown":{"instructions":["### Authlete versions","Authlete 3.0 is the current version. Unless the user says they use another version, answer for Authlete 3.0 using the 3.x documentation.","Documentation for Authlete 2.x (pages under `/v2/` and `/ja/v2/`) is for the legacy version. Refer to it only when the user is on Authlete 2.x.","","### Authlete architecture","Authlete is a backend engine for OAuth 2.0 and OpenID Connect processing. End users and client applications do not call it directly; the service provider's authorization server and API server call Authlete's APIs. Authlete handles protocol processing and token, client, and service management, while the service provider owns the OAuth/OIDC endpoints and user authentication.","See [Architecture](https://developers.authlete.com/get-started/introduction-to-authlete/architecture.md).","","### Concepts","If the user is new to Authlete, read these pages first:","- [Request and Response](https://developers.authlete.com/get-started/concepts/request-and-response.md): Core API requests pass the client's request parameters as-is, and responses return `resultCode`, `action`, and `responseContent`.","- [Action Handling](https://developers.authlete.com/get-started/concepts/action-handling.md): Branch on `action`, never on `resultCode`, and map each action to the HTTP response your server returns.","- [Two-Step API Calls](https://developers.authlete.com/get-started/concepts/two-step-api-calls.md): Actions such as `INTERACTION` are completed with a second call (`/auth/authorization/issue` or `/auth/authorization/fail`) linked by a `ticket`.","- [Management API Overview](https://developers.authlete.com/get-started/concepts/overview.md): The Management API configures services, manages clients, and operates issued tokens, separately from the protocol flows handled by the Core API.","- [API Authentication](https://developers.authlete.com/get-started/concepts/authentication.md): Authlete APIs use bearer tokens: a Service Access Token (one service) or an Organization Token (the whole organization)."]},"styling":{"latex":false},"navigation":{"languages":[{"language":"en","default":true,"href":"get-started/introduction-to-authlete"},{"language":"ja","href":"ja/get-started/introduction-to-authlete"}]}},"deployment":{"deploymentMetadataValue":{"subdomain":"authlete","hasAudioNarration":false,"actualSubdomain":"authlete","customDomains":["developers.authlete.com"],"gitSource":{"type":"github","owner":"authlete","repo":"developer-docs","deployBranch":"main","contentDirectory":"","isPrivate":true,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6ad86bfbbcc1b0bac5b9a633","collectionId":"102eb795-336b-4b91-aae6-f3939575b917","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6ad86bfbbcc1b0bac5b9a633"},"feedback":{"thumbs":true,"agentFeedback":true},"entitlements":{"AI_CHAT":{"status":"DISABLED"}},"buildId":"6ad86bfbbcc1b0bac5b9a633","clientVersion":"0.0.3965","searchFilterCounts":[{"language":"en","tag":"Release Notes","count":103},{"language":"ja","tag":"リリースノート","count":103},{"language":"ja","tag":"設定リファレンス","count":92},{"language":"default","tag":"API Reference","count":87},{"language":"default","tag":"Authlete","count":87},{"language":"en","tag":"Configuration Reference","count":83},{"language":"en","tag":"Protocols \u0026 Flows","count":46},{"language":"en","tag":"Deployment \u0026 Operations","count":44},{"language":"ja","tag":"プロトコル \u0026 フロー","count":42},{"language":"ja","tag":"デプロイと運用","count":39},{"language":"ja","tag":"トークン \u0026 クレーム","count":38},{"language":"ja","tag":"はじめに","count":34},{"language":"ja","tag":"エンドポイント","count":33},{"language":"en","tag":"Get Started","count":32},{"language":"en","tag":"Tokens and Claims","count":28},{"language":"default","tag":"Client Management","count":26},{"language":"en","tag":"Endpoints","count":25},{"language":"en","tag":"Server Releases (v2.2)","count":23},{"language":"en","tag":"Server Releases (v2.3)","count":23},{"language":"ja","tag":"サーバーリリース (v2.2)","count":23},{"language":"ja","tag":"サーバーリリース (v2.3)","count":23},{"language":"en","tag":"Server Releases (v3.0)","count":20},{"language":"ja","tag":"サーバーリリース (v3.0)","count":20},{"language":"default","tag":"Verifiable Credential Issuer","count":11},{"language":"default","tag":"Service Management","count":6},{"language":"default","tag":"Authorization Endpoint","count":5},{"language":"default","tag":"Token Operations","count":5},{"language":"default","tag":"CIBA","count":4},{"language":"default","tag":"Dynamic Client Registration","count":4},{"language":"default","tag":"Hardware Security Key","count":4}],"searchSettings":{"maxResults":7}},"assistantConfig":{},"hasChatPermissions":false,"hasWebMcpPermissions":false,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-v7-file-tree","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-nav-generations","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-agent-model-picker","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"privacy":{"consentBanner":{"enabled":true}},"isAtlas":false,"googleFontsInlined":false},"customCss":[{"filePath":"style.css","content":"#content-area,#navbar,#sidebar,[data-sidebar],body{background-image:none!important}.dynamic-curl-wrapper{width:100%;max-width:100%;min-width:0}.dynamic-curl-output{width:100%!important;max-width:100%!important;min-width:0!important}table[style*=tableLayout] td:last-child{overflow:hidden;min-width:0}table[style*=tableLayout] input{min-width:0}"}],"page":{"pagePath":"api-reference/token-endpoint/process-token-request","slug":"/api-reference/token-endpoint/process-token-request","pageMetadata":{"title":"Process Token Request","description":"This API parses request parameters of an authorization request and returns necessary data for the authorization server implementation to process the authorization request further.","deprecated":null,"version":null,"openapi":"https://spec.speakeasy.com/authlete/sdk-workspace/authlete-api-explorer-with-code-samples post /api/{serviceId}/auth/token","href":"/api-reference/token-endpoint/process-token-request","autogeneratedByOpenApi":true},"description":{"compiledSource":"\"use strict\";\nconst {jsx: _jsx} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n p: \"p\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsx(_components.p, {\n children: \"This API parses request parameters of an authorization request and returns necessary data for the authorization server implementation to process the authorization request further.\"\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,hr:`hr`,li:`li`,ol:`ol`,p:`p`,pre:`pre`,span:`span`,strong:`strong`,..._provideComponents(),...props.components},{Accordion,CodeBlock,Heading}=_components;if(!Accordion)_missingMdxReference(`Accordion`,true);if(!CodeBlock)_missingMdxReference(`CodeBlock`,true);if(!Heading)_missingMdxReference(`Heading`,true);return _jsxs(Accordion,{title:`Full description`,defaultOpen:false,id:`full-description`,children:[_jsxs(_components.p,{children:[`This API is supposed to be called from with the implementation of the token endpoint of the service. The endpoint implementation must extract the request parameters from the token request from the client application and pass them as the value of parameters request parameter to Authlete’s `,_jsx(_components.code,{children:`/auth/token`}),` API. The value of parameters is the entire entity body (which is formatted in `,_jsx(_components.code,{children:`application/x-www-form-urlencoded`}),`) of the token request. In addition, if the token endpoint of the authorization server implementation supports basic authentication as a means of `,_jsx(_components.a,{href:`https://datatracker.ietf.org/doc/html/rfc6749#section-2.3`,children:`client authentication`}),`, the client credentials must be extracted from `,_jsx(_components.code,{children:`Authorization`}),` header and they must be passed as `,_jsx(_components.code,{children:`clientId`}),` request parameter and `,_jsx(_components.code,{children:`clientSecret`}),` request parameter to Authlete’s `,_jsx(_components.code,{children:`/auth/token`}),` API. The following code snippet is an example in JAX-RS showing how to extract request parameters from the token request and client credentials from Authorization header.`]}),_jsx(CodeBlock,{numberOfLines:`18`,language:`java`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`java`,children:_jsxs(_components.code,{language:`java`,numberOfLines:`18`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`@`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#4EC9B0`},children:`POST`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`@`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#4EC9B0`},children:`Consumes`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`(`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:`MediaType`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`.`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:`APPLICATION_FORM_URLENCODED`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`)`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:`public`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:` Response`}),_jsx(_components.span,{style:{color:`#8250DF`,\"--shiki-dark\":`#DCDCAA`},children:` post`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`(`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`@`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#4EC9B0`},children:`HeaderParam`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`(`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:`HttpHeaders`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`.`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:`AUTHORIZATION`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`) `}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:`String`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` auth,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:`String`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` parameters)`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:`\u0026`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`#`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#B5CEA8`},children:`123`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`;`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#6E7781`,\"--shiki-dark\":`#6A9955`},children:`// Convert the value of Authorization header (credentials of`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#6E7781`,\"--shiki-dark\":`#6A9955`},children:`// the client application), if any, into BasicCredentials.`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:`BasicCredentials`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:` credentials`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:` =`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:` BasicCredentials`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`.`}),_jsx(_components.span,{style:{color:`#8250DF`,\"--shiki-dark\":`#DCDCAA`},children:`parse`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`(auth);`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#6E7781`,\"--shiki-dark\":`#6A9955`},children:`// The credentials of the client application extracted from`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#6E7781`,\"--shiki-dark\":`#6A9955`},children:`// 'Authorization' header. These may be null.`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:`String`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:` clientId`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:` =`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` credentials `}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:`==`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:` null`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#C586C0`},children:` ?`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:` null`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#C586C0`},children:`:`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:` credentials`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`.`}),_jsx(_components.span,{style:{color:`#8250DF`,\"--shiki-dark\":`#DCDCAA`},children:`getUserId`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`();`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:`String`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:` clientSecret`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:` =`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` credentials `}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:`==`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:` null`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#C586C0`},children:` ?`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:` null`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#C586C0`},children:`:`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:` credentials`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`.`}),_jsx(_components.span,{style:{color:`#8250DF`,\"--shiki-dark\":`#DCDCAA`},children:`getPassword`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`();`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#6E7781`,\"--shiki-dark\":`#6A9955`},children:`// Process the given parameters.`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#C586C0`},children:`return`}),_jsx(_components.span,{style:{color:`#8250DF`,\"--shiki-dark\":`#DCDCAA`},children:` process`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`(parameters, clientId, clientSecret);`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:`\u0026`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`#`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#B5CEA8`},children:`125`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`;`})]}),`\n`]})})}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Note`}),`: The `,_jsx(_components.code,{children:`jwtAtClaims`}),` request parameter is effective only when this API directly issues an access token, i.e., in the `,_jsx(_components.code,{children:`client_credentials`}),` grant flow (and the Native SSO branch of Token Exchange). For other grant flows, additional JWT claims must be set via the corresponding API instead: `,_jsx(_components.code,{children:`/auth/authorization/issue`}),` (authorization_code), `,_jsx(_components.code,{children:`/auth/backchannel/authentication/complete`}),` (CIBA), or `,_jsx(_components.code,{children:`/auth/device/complete`}),` (device_code). `,_jsx(_components.code,{children:`jwtAtClaims`}),` is silently ignored when sent with other grants.`]}),_jsxs(_components.p,{children:[`The response from `,_jsx(_components.code,{children:`/auth/token`}),` API has some parameters. Among them, it is action parameter that the service implementation should check first because it denotes the next action that the authorization server implementation should take. According to the value of action, the authorization server implementation must take the steps described below.`]}),_jsx(Heading,{level:`2`,id:`internal_server_error`,children:`INTERNAL_SERVER_ERROR`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`INTERNAL_SERVER_ERROR`}),`, it means that the request from the authorization server implementation was wrong or that an error occurred in Authlete. In either case, from the viewpoint of the client application, it is an error on the server side. Therefore, the service implementation should generate a response to the client application with HTTP status of “500 Internal Server Error”. Authlete recommends `,_jsx(_components.code,{children:`application/json`}),` as the content type although OAuth 2.0 specification does not mention the format of the error response when the redirect URI is not usable. The value of `,_jsx(_components.code,{children:`responseContent`}),` is a JSON string which describes the error, so it can be used as the entity body of the response.`]}),_jsx(_components.hr,{}),_jsx(_components.p,{children:`The following illustrates the response which the service implementation should generate and return to the client application.`}),_jsx(CodeBlock,{numberOfLines:`6`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`6`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 500 Internal Server Error`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(_components.p,{children:`The endpoint implementation may return another different response to the client application since “500 Internal Server Error” is not required by OAuth 2.0.`}),_jsx(Heading,{level:`2`,id:`invalid_client`,children:`INVALID_CLIENT`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`INVALID_CLIENT`}),`, it means that authentication of the client failed. In this case, the HTTP status of the response to the client application is either “400 Bad Request” or “401 Unauthorized”. This requirement comes from `,_jsx(_components.a,{href:`https://datatracker.ietf.org/doc/html/rfc6749#section-5.2`,children:`RFC 6749, 5.2. Error Response`}),`. The description about `,_jsx(_components.code,{children:`invalid_client`}),` shown below is an excerpt from RFC 6749.`]}),_jsx(_components.hr,{}),_jsxs(_components.p,{children:[`Client authentication failed (e.g., unknown client, no client authentication included, or unsupported authentication method). The authorization server MAY return an HTTP 401 (Unauthorized) status code to indicate which HTTP authentication schemes are supported. If the client attempted to authenticate via the `,_jsx(_components.code,{children:`Authorization`}),` request header field, the authorization server MUST respond with an HTTP 401 (Unauthorized) status code and include the `,_jsx(_components.code,{children:`WWW-Authenticate`}),` response header field matching the authentication scheme used by the client.`]}),_jsx(_components.hr,{}),_jsxs(_components.p,{children:[`In either case, the value of `,_jsx(_components.code,{children:`responseContent`}),` is a JSON string which can be used as the entity body of the response to the client application.`]}),_jsx(_components.hr,{}),_jsx(_components.p,{children:`The following illustrate responses which the service implementation must generate and return to the client application.`}),_jsx(CodeBlock,{numberOfLines:`6`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`6`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 400 Bad Request`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(CodeBlock,{numberOfLines:`7`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`7`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 401 Unauthorized`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`WWW-Authenticate: \u0026#123;challenge\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(Heading,{level:`2`,id:`bad_request`,children:`BAD_REQUEST`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`BAD_REQUEST`}),`, it means that the request from the client application is invalid. A response with HTTP status of “400 Bad Request” must be returned to the client application and the content type must be `,_jsx(_components.code,{children:`application/json`}),`. The value of `,_jsx(_components.code,{children:`responseContent`}),` is a JSON string which describes the error, so it can be used as the entity body of the response.`]}),_jsx(_components.p,{children:`The following illustrates the response which the service implementation should generate and return to the client application.`}),_jsx(CodeBlock,{numberOfLines:`6`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`6`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 400 Bad Request`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(Heading,{level:`2`,id:`password`,children:`PASSWORD`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`\"action\"`}),` is `,_jsx(_components.code,{children:`\"PASSWORD\"`}),`, it means that the request from the client application is valid and `,_jsx(_components.code,{children:`grant_type`}),` is `,_jsx(_components.code,{children:`\"password\"`}),`. That is, the flow is `,_jsx(_components.a,{href:`https://www.rfc-editor.org/rfc/rfc6749.html#section-4.3`,children:`“Resource Owner Password Credentials”`}),`. In this case, {@link #getUsername()} returns the value of `,_jsx(_components.code,{children:`\"username\"`}),` request parameter and {@link #getPassword()} returns the value of {@code “password”} request parameter which were contained in the token request from the client application. The service implementation must validate the credentials of the resource owner (= end-user) and take either of the actions below according to the validation result.`]}),_jsxs(_components.ol,{children:[`\n`,_jsxs(_components.li,{children:[`When the credentials are valid, call Authlete’s /auth/token/issue} API to generate an access token for the client application. The API requires `,_jsx(_components.code,{children:`\"ticket\"`}),` request parameter and `,_jsx(_components.code,{children:`\"subject\"`}),` request parameter. Use the value returned from {@link #getTicket()} method as the value for `,_jsx(_components.code,{children:`\"ticket\"`}),` parameter.`]}),`\n`,_jsxs(_components.li,{children:[`The response from `,_jsx(_components.code,{children:`/auth/token/issue`}),` API ({@link TokenIssueResponse}) contains data (an access token and others) which should be returned to the client application. Use the data to generate a response to the client application.`]}),`\n`,_jsxs(_components.li,{children:[`When the credentials are invalid, call Authlete’s {@code /auth/token/fail} API with `,_jsx(_components.code,{children:`reason=`}),`{@link TokenFailRequest.Reason#INVALID_RESOURCE_OWNER_CREDENTIALS INVALID_RESOURCE_OWNER_CREDENTIALS} to generate an error response for the client application. The API requires `,_jsx(_components.code,{children:`\"ticket\"`}),` request parameter. Use the value returned from {@link #getTicket()} method as the value for `,_jsx(_components.code,{children:`\"ticket\"`}),` parameter.`]}),`\n`,_jsxs(_components.li,{children:[`The response from `,_jsx(_components.code,{children:`/auth/token/fail`}),` API ({@link TokenFailResponse}) contains error information which should be returned to the client application. Use it to generate a response to the client application.`]}),`\n`]}),_jsx(Heading,{level:`2`,id:`ok`,children:`OK`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`OK`}),`, it means that the request from the client application is valid and an access token, and optionally an ID token, is ready to be issued. The HTTP status of the response returned to the client application must be “200 OK” and the content type must be `,_jsx(_components.code,{children:`application/json`}),`. The value of `,_jsx(_components.code,{children:`responseContent`}),` is a JSON string which contains an access token (and optionally an ID token), so it can be used as the entity body of the response.`]}),_jsx(_components.hr,{}),_jsx(_components.p,{children:`The following illustrates the response which the service implementation must generate and return to the client application.`}),_jsx(CodeBlock,{numberOfLines:`6`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`6`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 200 OK`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(Heading,{level:`2`,id:`token_exchange-authlete-2-3-onwards`,children:`TOKEN_EXCHANGE (Authlete 2.3 onwards)`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`\"action\"`}),` is `,_jsx(_components.code,{children:`\"TOKEN_EXCHANGE\"`}),`, it means that the request from the client application is a valid token exchange request (cf. `,_jsx(_components.a,{href:`https://www.rfc-editor.org/rfc/rfc8693.html`,children:`RFC 8693 OAuth 2.0 Token Exchange`}),`) and that the request has already passed the following validation steps.`]}),_jsxs(_components.ol,{children:[`\n`,_jsxs(_components.li,{children:[`Confirm that the value of the `,_jsx(_components.code,{children:`requested_token_type`}),` request parameter is one of the registered token type identifiers if the request parameter is given and its value is not empty.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the `,_jsx(_components.code,{children:`subject_token`}),` request parameter is given and its value is not empty.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the `,_jsx(_components.code,{children:`subject_token_type`}),` request parameter is given and its value is one of the registered token type identifiers.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the `,_jsx(_components.code,{children:`actor_token_type`}),` request parameter is given and its value is one of the registered token type identifiers if the `,_jsx(_components.code,{children:`actor_token`}),` request parameter is given and its value is not empty.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the `,_jsx(_components.code,{children:`actor_token_type`}),` request parameter is not given or its value is empty when the `,_jsx(_components.code,{children:`actor_token`}),` request parameter is not given or its value is empty. Furthermore, Authlete performs additional validation on the tokens specified by the `,_jsx(_components.code,{children:`subject_token`}),` request parameter and the `,_jsx(_components.code,{children:`actor_token`}),` request parameter according to their respective token types as shown below.`]}),`\n`]}),_jsx(Heading,{level:`2`,id:`token-validation-steps`,children:`Token Validation Steps`}),_jsxs(_components.p,{children:[`*Token Type: `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:jwt`}),`*`]}),_jsxs(_components.ol,{children:[`\n`,_jsxs(_components.li,{children:[`Confirm that the format conforms to the JWT specification [RFC 7519][`,_jsx(_components.a,{href:`https://www.rfc-editor.org/rfc/rfc7519.html`,children:`https://www.rfc-editor.org/rfc/rfc7519.html`}),`].`]}),`\n`,_jsxs(_components.li,{children:[`Check if the JWT is encrypted and if it is encrypted, then (a) reject the token exchange request when the {@link Service#isTokenExchangeEncryptedJwtRejected() tokenExchangeEncryptedJwtRejected} flag of the service is `,_jsx(_components.code,{children:`true`}),` or (b) skip remaining validation steps when the flag is `,_jsx(_components.code,{children:`false`}),`. Note that Authlete does not verify an encrypted JWT because there is no standard way to obtain the key to decrypt the JWT with. This means that you must verify an encrypted JWT by yourself when one is used as an input token with the token type { @code “urn:ietf:params:oauth:token-type:jwt” }.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the current time has not reached the time indicated by the `,_jsx(_components.code,{children:`exp`}),` claim if the JWT contains the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the current time is equal to or after the time indicated by the `,_jsx(_components.code,{children:`iat`}),` claim if the JWT contains the claim. 5.Confirm that the current time is equal to or after the time indicated by the `,_jsx(_components.code,{children:`nbf`}),` claim if the JWT contains the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Check if the JWT is signed and if it is not signed, then (a) reject the token exchange request when the {@link Service#isTokenExchangeUnsignedJwtRejected() tokenExchangeUnsignedJwtRejected} flag of the service is `,_jsx(_components.code,{children:`true`}),` or (b) finish validation on the input token. Note that Authlete does not verify the signature of the JWT because there is no standard way to obtain the key to verify the signature of a JWT with. This means that you must verify the signature by yourself when a signed JWT is used as an input token with the token type `,_jsx(_components.code,{children:`\"urn:ietf:params:oauth:token-type:jwt\"`}),`. *Token Type: `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:access_token`}),`*`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the token is an access token that has been issued by the Authlete server of your service. This implies that access tokens issued by other systems cannot be used as a subject token or an actor token with the token type `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:access_token`}),`.`]}),`\n`,_jsx(_components.li,{children:`Confirm that the access token has not expired.`}),`\n`,_jsxs(_components.li,{children:[`Confirm that the access token belongs to the service. *Token Type: `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:refresh_token`}),`*`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the token is a refresh token that has been issued by the Authlete server of your service. This implies that refresh tokens issued by other systems cannot be used as a subject token or an actor token with the token type `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:refresh_token`}),`.`]}),`\n`,_jsx(_components.li,{children:`Confirm that the refresh token has not expired.`}),`\n`,_jsxs(_components.li,{children:[`Confirm that the refresh token belongs to the service. *Token Type: `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:id_token`}),`*`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the format conforms to the JWT specification (`,_jsx(_components.a,{href:`https://www.rfc-editor.org/rfc/rfc7519.html`,children:`RFC 7519`}),`).`]}),`\n`,_jsxs(_components.li,{children:[`Check if the ID Token is encrypted and if it is encrypted, then (a) reject the token exchange request when the {@link Service#isTokenExchangeEncryptedJwtRejected() tokenExchangeEncryptedJwtRejected} flag of the service is `,_jsx(_components.code,{children:`true`}),` or (b) skip remaining validation steps when the flag is `,_jsx(_components.code,{children:`false`}),`. Note that Authlete does not verify an encrypted ID Token because there is no standard way to obtain the key to decrypt the ID Token with in the context of token exchange where the client ID for the encrypted ID Token cannot be determined. This means that you must verify an encrypted ID Token by yourself when one is used as an input token with the token type `,_jsx(_components.code,{children:`\"urn:ietf:params:oauth:token-type:id_token\"`}),`.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the ID Token contains the `,_jsx(_components.code,{children:`exp`}),` claim and the current time has not reached the time indicated by the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the ID Token contains the `,_jsx(_components.code,{children:`iat`}),` claim and the current time is equal to or after the time indicated by the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the current time is equal to or after the time indicated by the `,_jsx(_components.code,{children:`nbf`}),` claim if the ID Token contains the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the ID Token contains the `,_jsx(_components.code,{children:`iss`}),` claim and the value is a valid URI. In addition, confirm that the URI has the `,_jsx(_components.code,{children:`https`}),` scheme, no query component and no fragment component.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the ID Token contains the `,_jsx(_components.code,{children:`aud`}),` claim and its value is a JSON string or an array of JSON strings.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the value of the `,_jsx(_components.code,{children:`nonce`}),` claim is a JSON string if the ID Token contains the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Check if the ID Token is signed and if it is not signed, then (a) reject the token exchange request when the {@link Service#isTokenExchangeUnsignedJwtRejected() tokenExchangeUnsignedJwtRejected} flag of the service is `,_jsx(_components.code,{children:`true`}),` or (b) finish validation on the input token.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the signature algorithm is asymmetric. This implies that ID Tokens whose signature algorithm is symmetric (`,_jsx(_components.code,{children:`HS256`}),`, `,_jsx(_components.code,{children:`HS384`}),` or `,_jsx(_components.code,{children:`HS512`}),`) cannot be used as a subject token or an actor token with the token type `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:id_token`}),`.`]}),`\n`,_jsxs(_components.li,{children:[`Verify the signature of the ID Token. Signature verification is performed even in the case where the issuer of the ID Token is not your service. But in that case, the issuer must support the discovery endpoint defined in `,_jsx(_components.a,{href:`https://openid.net/specs/openid-connect-discovery-1_0.html`,children:`OpenID Connect Discovery 1.0`}),`. Otherwise, signature verification fails. *Token Type: `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:saml1`}),`* (Authlete does not perform any validation for this token type.) *Token Type: `,_jsx(_components.code,{children:`urn:ietf:params:oauth:token-type:saml2`}),`* (Authlete does not perform any validation for this token type.) The specification of Token Exchange (`,_jsx(_components.a,{href:`https://www.rfc-editor.org/rfc/rfc8693.html`,children:`RFC 8693`}),`) is very flexible. In other words, the specification has abandoned the task of determining details. Therefore, for secure token exchange, you have to complement the specification with your own rules. For that purpose, Authlete provides some configuration options as listed below. Authorization server implementers may utilize them and/or implement their own rules. In the case of {@link Action#TOKEN_EXCHANGE TOKEN_EXCHANGE}, the {@link #getResponseContent()} method returns `,_jsx(_components.code,{children:`null`}),`. You have to construct the token response by yourself. For example, you may generate an access token by calling Authlete’s `,_jsx(_components.code,{children:`/api/auth/token/create`}),` API and construct a token response like below.`]}),`\n`]}),_jsx(CodeBlock,{numberOfLines:`7`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`7`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 401 Unauthorized`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`WWW-Authenticate: \u0026#123;challenge\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(CodeBlock,{numberOfLines:`11`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`11`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 200 OK`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-cache, no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"access_token\": \"\u0026#123;@link TokenCreateResponse#getAccessToken()\u0026#125;\",`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"issued_token_type\": \"urn:ietf:params:oauth:token-type:access_token\",`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"token_type\": \"Bearer\",`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"expires_in\": \u0026#123; @link TokenCreateResponse#getExpiresIn() \u0026#125;,`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"scope\": \"String.join(\" \", \u0026#123;@link TokenCreateResponse#getScopes()\u0026#125;)\"`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(Heading,{level:`2`,id:`jwt_bearer-jwt_bearer-authlete-2-3-onwards`,children:`JWT_BEARER JWT_BEARER (Authlete 2.3 onwards)`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`\"action\"`}),` is `,_jsx(_components.code,{children:`\"JWT_BEARER\"`}),`, it means that the request from the client application is a valid token request with the grant type `,_jsx(_components.code,{children:`\"urn:ietf:params:oauth:grant-type:jwt-bearer\"`}),` (`,_jsx(_components.a,{href:`https://www.rfc-editor.org/rfc/rfc7523.html`,children:`RFC 7523 JSON Web Token (JWT) Profile for OAuth 2.0 Client Authentication and Authorization Grants`}),`) and that the request has already passed the following validation steps.`]}),_jsxs(_components.ol,{children:[`\n`,_jsxs(_components.li,{children:[`Confirm that the `,_jsx(_components.code,{children:`assertion`}),` request parameter is given and its value is not empty.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the format of the assertion conforms to the JWT specification (`,_jsx(_components.a,{href:`https://www.rfc-editor.org/rfc/rfc7519.html`,children:`RFC 7519`}),`).`]}),`\n`,_jsxs(_components.li,{children:[`Check if the JWT is encrypted and if it is encrypted, then (a) reject the token request when the {@link Service#isJwtGrantEncryptedJwtRejected() jwtGrantEncryptedJwtRejected} flag of the service is `,_jsx(_components.code,{children:`true`}),` or (b) skip remaining validation steps when the flag is `,_jsx(_components.code,{children:`false`}),`. Note that Authlete does not verify an encrypted JWT because there is no standard way to obtain the key to decrypt the JWT with. This means that you must verify an encrypted JWT by yourself.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the JWT contains the `,_jsx(_components.code,{children:`iss`}),` claim and its value is a JSON string.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the JWT contains the `,_jsx(_components.code,{children:`sub`}),` claim and its value is a JSON string.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the JWT contains the `,_jsx(_components.code,{children:`aud`}),` claim and its value is either a JSON string or an array of JSON strings.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the issuer identifier of the service (cf. {@link Service#getIssuer()}) or the URL of the token endpoint (cf. {@link Service#getTokenEndpoint()}) is listed as audience in the `,_jsx(_components.code,{children:`aud`}),` claim.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the JWT contains the `,_jsx(_components.code,{children:`exp`}),` claim and the current time has not reached the time indicated by the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the current time is equal to or after the time indicated by by the `,_jsx(_components.code,{children:`iat`}),` claim if the JWT contains the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Confirm that the current time is equal to or after the time indicated by by the `,_jsx(_components.code,{children:`nbf`}),` claim if the JWT contains the claim.`]}),`\n`,_jsxs(_components.li,{children:[`Check if the JWT is signed and if it is not signed, then (a) reject the token request when the {@link Service#isJwtGrantUnsignedJwtRejected() jwtGrantUnsignedJwtRejected} flag of the service is `,_jsx(_components.code,{children:`true`}),` or (b) finish validation on the JWT. Note that Authlete does not verify the signature of the JWT because there is no standard way to obtain the key to verify the signature of a JWT with. This means that you must verify the signature by yourself. Authlete provides some configuration options for the grant type as listed below. Authorization server implementers may utilize them and/or implement their own rules.`]}),`\n`]}),_jsx(CodeBlock,{numberOfLines:`10`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`10`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 200 OK`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-cache, no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"access_token\": \"\u0026#123;@link TokenCreateResponse#getAccessToken()\u0026#125;\",`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"token_type\": \"Bearer\",`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"expires_in\": \u0026#123;@link TokenCreateResponse#getExpiresIn()\u0026#125;,`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\"scope\": \"String.join(\" \", \u0026#123;@link TokenCreateResponse#getScopes()\u0026#125;)\"`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsxs(_components.p,{children:[`Finally, note again that Authlete does not verify the signature of the JWT specified by the `,_jsx(_components.code,{children:`assertion`}),` request parameter. You must verify the signature by yourself.`]})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Process Token Request","description":"This API parses request parameters of an authorization request and returns necessary data for the authorization server implementation to process the authorization request further.","deprecated":null,"version":null,"openapi":"https://spec.speakeasy.com/authlete/sdk-workspace/authlete-api-explorer-with-code-samples post /api/{serviceId}/auth/token","href":"/api-reference/token-endpoint/process-token-request","autogeneratedByOpenApi":true}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":["/_mintlify/custom/authlete/a07b398e9c8556ba/snippets/oauth-dynamic.js"],"openApiReferenceData":{"operation":{"summary":"Process Token Request","description":"This API parses request parameters of an authorization request and returns necessary data for the authorization server implementation to process the authorization request further.","x-mint":{"metadata":{"description":"This API parses request parameters of an authorization request and returns necessary data for the authorization server implementation to process the authorization request further."},"content":"\u003cAccordion title=\"Full description\" defaultOpen={false}>\nThis API is supposed to be called from with the implementation of the token endpoint of the service. The endpoint implementation must extract the request parameters from the token request from the client application and pass them as the value of parameters request parameter to Authlete's `/auth/token` API. The value of parameters is the entire entity body (which is formatted in `application/x-www-form-urlencoded`) of the token request. In addition, if the token endpoint of the authorization server implementation supports basic authentication as a means of [client authentication](https://datatracker.ietf.org/doc/html/rfc6749#section-2.3), the client credentials must be extracted from `Authorization` header and they must be passed as `clientId` request parameter and `clientSecret` request parameter to Authlete's `/auth/token` API. The following code snippet is an example in JAX-RS showing how to extract request parameters from the token request and client credentials from Authorization header.\n```java\n@POST\n@Consumes(MediaType.APPLICATION_FORM_URLENCODED)\npublic Response post(\n@HeaderParam(HttpHeaders.AUTHORIZATION) String auth,\nString parameters)\n\u0026#123;\n// Convert the value of Authorization header (credentials of\n// the client application), if any, into BasicCredentials.\nBasicCredentials credentials = BasicCredentials.parse(auth);\n// The credentials of the client application extracted from\n// 'Authorization' header. These may be null.\nString clientId = credentials == null ? null\n: credentials.getUserId();\nString clientSecret = credentials == null ? null\n: credentials.getPassword();\n// Process the given parameters.\nreturn process(parameters, clientId, clientSecret);\n\u0026#125;\n```\n**Note**: The `jwtAtClaims` request parameter is effective only when this API directly issues an access token, i.e., in the `client_credentials` grant flow (and the Native SSO branch of Token Exchange). For other grant flows, additional JWT claims must be set via the corresponding API instead: `/auth/authorization/issue` (authorization_code), `/auth/backchannel/authentication/complete` (CIBA), or `/auth/device/complete` (device_code). `jwtAtClaims` is silently ignored when sent with other grants.\n\nThe response from `/auth/token` API has some parameters. Among them, it is action parameter that the service implementation should check first because it denotes the next action that the authorization server implementation should take. According to the value of action, the authorization server implementation must take the steps described below.\n\n## INTERNAL_SERVER_ERROR\n\nWhen the value of `action` is `INTERNAL_SERVER_ERROR`, it means that the request from the authorization server implementation was wrong or that an error occurred in Authlete. In either case, from the viewpoint of the client application, it is an error on the server side. Therefore, the service implementation should generate a response to the client application with HTTP status of \"500 Internal Server Error\". Authlete recommends `application/json` as the content type although OAuth 2.0 specification does not mention the format of the error response when the redirect URI is not usable. The value of `responseContent` is a JSON string which describes the error, so it can be used as the entity body of the response.\n\n---\n\nThe following illustrates the response which the service implementation should generate and return to the client application.\n```\nHTTP/1.1 500 Internal Server Error\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\nThe endpoint implementation may return another different response to the client application since \"500 Internal Server Error\" is not required by OAuth 2.0.\n\n## INVALID_CLIENT\n\nWhen the value of `action` is `INVALID_CLIENT`, it means that authentication of the client failed. In this case, the HTTP status of the response to the client application is either \"400 Bad Request\" or \"401 Unauthorized\". This requirement comes from [RFC 6749, 5.2. Error Response](https://datatracker.ietf.org/doc/html/rfc6749#section-5.2). The description about `invalid_client` shown below is an excerpt from RFC 6749.\n\n---\n\nClient authentication failed (e.g., unknown client, no client authentication included, or unsupported authentication method). The authorization server MAY return an HTTP 401 (Unauthorized) status code to indicate which HTTP authentication schemes are supported. If the client attempted to authenticate via the `Authorization` request header field, the authorization server MUST respond with an HTTP 401 (Unauthorized) status code and include the `WWW-Authenticate` response header field matching the authentication scheme used by the client.\n\n---\n\nIn either case, the value of `responseContent` is a JSON string which can be used as the entity body of the response to the client application.\n\n---\n\nThe following illustrate responses which the service implementation must generate and return to the client application.\n\n```\nHTTP/1.1 400 Bad Request\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\n\n```\nHTTP/1.1 401 Unauthorized\nWWW-Authenticate: \u0026#123;challenge\u0026#125;\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\n\n## BAD_REQUEST\n\nWhen the value of `action` is `BAD_REQUEST`, it means that the request from the client application is invalid. A response with HTTP status of \"400 Bad Request\" must be returned to the client application and the content type must be `application/json`. The value of `responseContent` is a JSON string which describes the error, so it can be used as the entity body of the response.\n\nThe following illustrates the response which the service implementation should generate and return to the client application.\n\n```\nHTTP/1.1 400 Bad Request\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\n\n## PASSWORD\n\nWhen the value of `\"action\"` is `\"PASSWORD\"`, it means that the request from the client application is valid and `grant_type` is `\"password\"`. That is, the flow is [\"Resource Owner Password Credentials\"](https://www.rfc-editor.org/rfc/rfc6749.html#section-4.3). In this case, \u0026#123;@link #getUsername()\u0026#125; returns the value of `\"username\"` request parameter and \u0026#123;@link #getPassword()\u0026#125; returns the value of \u0026#123;@code \"password\"\u0026#125; request parameter which were contained in the token request from the client application. The service implementation must validate the credentials of the resource owner (= end-user) and take either of the actions below according to the validation result.\n1. When the credentials are valid, call Authlete's /auth/token/issue\u0026#125; API to generate an access token for the client application. The API requires `\"ticket\"` request parameter and `\"subject\"` request parameter. Use the value returned from \u0026#123;@link #getTicket()\u0026#125; method as the value for `\"ticket\"` parameter.\n2. The response from `/auth/token/issue` API (\u0026#123;@link TokenIssueResponse\u0026#125;) contains data (an access token and others) which should be returned to the client application. Use the data to generate a response to the client application.\n3. When the credentials are invalid, call Authlete's \u0026#123;@code /auth/token/fail\u0026#125; API with `reason=`\u0026#123;@link TokenFailRequest.Reason#INVALID_RESOURCE_OWNER_CREDENTIALS INVALID_RESOURCE_OWNER_CREDENTIALS\u0026#125; to generate an error response for the client application. The API requires `\"ticket\"` request parameter. Use the value returned from \u0026#123;@link #getTicket()\u0026#125; method as the value for `\"ticket\"` parameter.\n4. The response from `/auth/token/fail` API (\u0026#123;@link TokenFailResponse\u0026#125;) contains error information which should be returned to the client application. Use it to generate a response to the client application.\n\n## OK\n\nWhen the value of `action` is `OK`, it means that the request from the client application is valid and an access token, and optionally an ID token, is ready to be issued. The HTTP status of the response returned to the client application must be \"200 OK\" and the content type must be `application/json`. The value of `responseContent` is a JSON string which contains an access token (and optionally an ID token), so it can be used as the entity body of the response.\n\n---\n\nThe following illustrates the response which the service implementation must generate and return to the client application.\n```\nHTTP/1.1 200 OK\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\n\n## TOKEN_EXCHANGE (Authlete 2.3 onwards)\n\nWhen the value of `\"action\"` is `\"TOKEN_EXCHANGE\"`, it means that the request from the client application is a valid token exchange request (cf. [RFC 8693 OAuth 2.0 Token Exchange](https://www.rfc-editor.org/rfc/rfc8693.html)) and that the request has already passed the following validation steps.\n1. Confirm that the value of the `requested_token_type` request parameter is one of the registered token type identifiers if the request parameter is given and its value is not empty.\n2. Confirm that the `subject_token` request parameter is given and its value is not empty.\n3. Confirm that the `subject_token_type` request parameter is given and its value is one of the registered token type identifiers.\n4. Confirm that the `actor_token_type` request parameter is given and its value is one of the registered token type identifiers if the `actor_token` request parameter is given and its value is not empty.\n5. Confirm that the `actor_token_type` request parameter is not given or its value is empty when the `actor_token` request parameter is not given or its value is empty. Furthermore, Authlete performs additional validation on the tokens specified by the `subject_token` request parameter and the `actor_token` request parameter according to their respective token types as shown below.\n\n## Token Validation Steps\n\\*Token Type: `urn:ietf:params:oauth:token-type:jwt`\\*\n1. Confirm that the format conforms to the JWT specification [RFC 7519][https://www.rfc-editor.org/rfc/rfc7519.html].\n2. Check if the JWT is encrypted and if it is encrypted, then (a) reject the token exchange request when the \u0026#123;@link Service#isTokenExchangeEncryptedJwtRejected() tokenExchangeEncryptedJwtRejected\u0026#125; flag of the service is `true` or (b) skip remaining validation steps when the flag is `false`. Note that Authlete does not verify an encrypted JWT because there is no standard way to obtain the key to decrypt the JWT with. This means that you must verify an encrypted JWT by yourself when one is used as an input token with the token type \u0026#123; @code \"urn:ietf:params:oauth:token-type:jwt\" \u0026#125;.\n3. Confirm that the current time has not reached the time indicated by the `exp` claim if the JWT contains the claim.\n4. Confirm that the current time is equal to or after the time indicated by the `iat` claim if the JWT contains the claim. 5.Confirm that the current time is equal to or after the time indicated by the `nbf` claim if the JWT contains the claim.\n6. Check if the JWT is signed and if it is not signed, then (a) reject the token exchange request when the \u0026#123;@link Service#isTokenExchangeUnsignedJwtRejected() tokenExchangeUnsignedJwtRejected\u0026#125; flag of the service is `true` or (b) finish validation on the input token. Note that Authlete does not verify the signature of the JWT because there is no standard way to obtain the key to verify the signature of a JWT with. This means that you must verify the signature by yourself when a signed JWT is used as an input token with the token type `\"urn:ietf:params:oauth:token-type:jwt\"`. \\*Token Type: `urn:ietf:params:oauth:token-type:access_token`\\*\n1. Confirm that the token is an access token that has been issued by the Authlete server of your service. This implies that access tokens issued by other systems cannot be used as a subject token or an actor token with the token type `urn:ietf:params:oauth:token-type:access_token`.\n2. Confirm that the access token has not expired.\n3. Confirm that the access token belongs to the service. \\*Token Type: `urn:ietf:params:oauth:token-type:refresh_token`\\*\n1. Confirm that the token is a refresh token that has been issued by the Authlete server of your service. This implies that refresh tokens issued by other systems cannot be used as a subject token or an actor token with the token type `urn:ietf:params:oauth:token-type:refresh_token`.\n2. Confirm that the refresh token has not expired.\n3. Confirm that the refresh token belongs to the service. \\*Token Type: `urn:ietf:params:oauth:token-type:id_token`\\*\n1. Confirm that the format conforms to the JWT specification ([RFC 7519](https://www.rfc-editor.org/rfc/rfc7519.html)).\n2. Check if the ID Token is encrypted and if it is encrypted, then (a) reject the token exchange request when the \u0026#123;@link Service#isTokenExchangeEncryptedJwtRejected() tokenExchangeEncryptedJwtRejected\u0026#125; flag of the service is `true` or (b) skip remaining validation steps when the flag is `false`. Note that Authlete does not verify an encrypted ID Token because there is no standard way to obtain the key to decrypt the ID Token with in the context of token exchange where the client ID for the encrypted ID Token cannot be determined. This means that you must verify an encrypted ID Token by yourself when one is used as an input token with the token type `\"urn:ietf:params:oauth:token-type:id_token\"`.\n3. Confirm that the ID Token contains the `exp` claim and the current time has not reached the time indicated by the claim.\n4. Confirm that the ID Token contains the `iat` claim and the current time is equal to or after the time indicated by the claim.\n5. Confirm that the current time is equal to or after the time indicated by the `nbf` claim if the ID Token contains the claim.\n6. Confirm that the ID Token contains the `iss` claim and the value is a valid URI. In addition, confirm that the URI has the `https` scheme, no query component and no fragment component.\n7. Confirm that the ID Token contains the `aud` claim and its value is a JSON string or an array of JSON strings.\n8. Confirm that the value of the `nonce` claim is a JSON string if the ID Token contains the claim.\n9. Check if the ID Token is signed and if it is not signed, then (a) reject the token exchange request when the \u0026#123;@link Service#isTokenExchangeUnsignedJwtRejected() tokenExchangeUnsignedJwtRejected\u0026#125; flag of the service is `true` or (b) finish validation on the input token.\n10. Confirm that the signature algorithm is asymmetric. This implies that ID Tokens whose signature algorithm is symmetric (`HS256`, `HS384` or `HS512`) cannot be used as a subject token or an actor token with the token type `urn:ietf:params:oauth:token-type:id_token`.\n11. Verify the signature of the ID Token. Signature verification is performed even in t
[...]
